//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

PrecacheModel(API_GetString("boost_token_model"));
PrecacheScriptSound("Halloween.spell_pickup");

::token_pickups <- {};
::token_drop_chance_ally <- 5;
::token_drop_chance_enemy <- 3;
::token_drop_chance_neutral <- 3;
::token_drop_chance_empty <- 2;

OnGameEvent("player_death", 0, function(player, params)
{
    //todo fix
    /*if (vipBoostTokens <= 1)
    {
        if (RandomInt(1, token_drop_chance_empty) != 1)
            return;
    }
    else*/ if (!API_GetBool("is_attack_defend"))
    {
        if (RandomInt(1, token_drop_chance_neutral) != 1)
            return;
    }
    else if (GetFakeTeam(player) == TF_TEAM_RED)
    {
        if (RandomInt(1, token_drop_chance_enemy) != 1)
            return;
    }
    else if (RandomInt(1, token_drop_chance_ally) != 1)
        return;

    if (IsVIP(player))
        return;

    local team = GetFakeTeam(player);
    local vip = GetValidVIP(team);
    if (!IsValidPlayer(vip))
        return;

    local proxy_entity = Entities.CreateByClassname("obj_sentrygun");
    SetPropBool(proxy_entity, "m_bForcePurgeFixedupStrings", true);
    proxy_entity.SetAbsOrigin(player.GetOrigin());
    proxy_entity.SetAbsAngles(QAngle());
    proxy_entity.DispatchSpawn();
    proxy_entity.SetModel(API_GetString("boost_token_model"));
    proxy_entity.AddEFlags(Constants.FEntityEFlags.EFL_NO_THINK_FUNCTION)
    proxy_entity.SetSolid(Constants.ESolidType.SOLID_NONE);
    SetPropBool(proxy_entity, "m_bPlacing", true);
    SetPropInt(proxy_entity, "m_fObjectFlags", 2);
    SetPropEntity(proxy_entity, "m_hBuilder", vip);
    EntFireByHandle(proxy_entity, "Kill", "", 20, null, null);

    token_pickups[proxy_entity] <- team;
});

AddTimer(0.1, -1, function()
{
    foreach(vip in GetValidVIPs())
    {
        local vipOrigin = vip.GetOrigin();
        local vipTeam = GetFakeTeam(vip);
        foreach(tokenEnt, team in token_pickups)
        {
            if (!tokenEnt || !tokenEnt.IsValid())
                delete token_pickups[tokenEnt];
            else if (team == vipTeam && (vipOrigin - tokenEnt.GetOrigin()).Length() < 64)
            {
                delete token_pickups[tokenEnt];
                tokenEnt.Kill();
                vip.GetScriptScope().vipBoostTokens++;
                vip.GetScriptScope().vipBoostTokensMax++;
                EmitSoundOnClient("Halloween.spell_pickup", vip);
                return;
            }
        }
    }
});