//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

capTriggerTimeStamps <- [0, 0, 0, 0, 0];

for (local trigger = null; trigger = Entities.FindByClassname(trigger, "trigger_capture_area");)
{
    EntityOutputs.AddOutput(trigger,
        "OnStartTouch",
        "!self",
        "RunScriptCode",
        "main_script.OnVIPStartTounch(activator, self)",
        0, -1);
    EntityOutputs.AddOutput(trigger,
        "OnEndTouch",
        "!self",
        "RunScriptCode",
        "main_script.OnVIPEndTounch(activator, self)",
        0, -1);
    trigger.KeyValueFromString("filtername", "filter_captrigger");
}

function OnVIPStartTounch(vip, trigger)
{
    if (!IsVIP(vip) || Time() - capTriggerTimeStamps[GetFakeTeam(vip)] < 0.15)
        return;

    capTriggerTimeStamps[GetFakeTeam(vip)] = Time();
    foreach(player in GetAllClients())
    {
        if (GetFakeTeam(player) == GetFakeTeam(vip) && player != vip)
            player.KeyValueFromString("targetname", "capturer");
    }
    EntFireByHandle(trigger, "Disable", "", -1, null, null);
    EntFireByHandle(trigger, "Enable", "", 0.1, null, null);
}

function OnVIPEndTounch(vip, trigger)
{
    if (!IsVIP(vip) || Time() - capTriggerTimeStamps[GetFakeTeam(vip)] < 0.15)
        return;

    capTriggerTimeStamps[GetFakeTeam(vip)] = Time();
    foreach(player in GetAllClients())
    {
        if (GetFakeTeam(player) == GetFakeTeam(vip) && player != vip)
            player.KeyValueFromString("targetname", "");
    }
    EntFireByHandle(trigger, "Disable", "", -1, null, null);
    EntFireByHandle(trigger, "Enable", "", 0.1, null, null);
}