//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

vipBoostTokensStart <- 3;
vipBoostTokensMax <- 3;
vipBoostTokens <- 3;
pressedAttack2 <- false;
pressedReload <- false;
selectedBuffType <- 0;
lastTimeUsedOn <- 0;
lastPlayerUsedOn <- 0;
tokenRecharge <- 0;
buffDuration <- 8;
myTeam <- GetFakeTeam(self);

PrecacheScriptSound("Player.DenyWeaponSelection")
PrecacheScriptSound("WeaponMedigun_Vaccinator.Toggle")
PrecacheScriptSound("Player.HitSoundRetro")
PrecacheScriptSound("Player.DenyWeaponSelection")

game_text_vip_boost <- SpawnEntityFromTable("game_text",
{
    color = "236 227 203",
    color2 = "0 0 0",
    channel = 5,
    holdtime = 5,
    message = "",
    x = -1,
    y = 0.6
});

AddTimer(0.1, 0, function()
{
    if (vipBoostTokens >= vipBoostTokensMax)
    {
        tokenRecharge = 0;
        return;
    }
    tokenRecharge += 2;
    if (tokenRecharge >= 100)
    {
        vipBoostTokens ++;
        tokenRecharge = 0;
    }
});

AddTimer(-1, 0, function()
{
    local buttons = GetPropInt(self, "m_nButtons");

    local selectedBuffTypeStr = selectedBuffType == 0 ? "Mini-Crits" : selectedBuffType == 1 ? "Speed Boost" : "Damage Res."
    EntFireByHandle(game_text_vip_boost "AddOutput",
    "message (Reload) Selected buff∶ " + selectedBuffTypeStr
        +"\nBuff Tokens∶ " + vipBoostTokens+BigToSmallNumbers(tokenRecharge)
        +"\nPlayers near Point∶ "+playersOnCountCounter
        +"\nPick up extra tokens from dead players", 0, self, self);
    EntFireByHandle(game_text_vip_boost "Display", "", 0, self, self);

    if (self.IsUsingActionSlot()
        || (buttons & IN_ATTACK3)
        || (buttons & IN_RELOAD))
    {
        if (pressedReload)
            return;
        pressedReload = true;
        selectedBuffType++;
        EmitSoundOnClient("WeaponMedigun_Vaccinator.Toggle", self);
        lastTimeUsedOn = 0;
        if (selectedBuffType > 2)
            selectedBuffType = 0;
    }
    else if (pressedReload)
        pressedReload = false;
    if (buttons & IN_ATTACK2)
    {
        if (pressedAttack2)
            return;
        else
        {
            pressedAttack2 = true;

            if (vipBoostTokens <= 0)
            {
                EmitSoundOnClient("Player.DenyWeaponSelection", self);
                return;
            }

            local forward = self.EyeAngles().Forward();
            local eyePos = self.EyePosition();

            local trace = {
                start = eyePos,
                end = eyePos + forward * 5500,
                mask = Constants.FContents.CONTENTS_HITBOX|Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
                ignore = self
            };
            TraceLineEx(trace);
            local target = safeget(trace, "enthit", worldspawn);
            if (target == worldspawn)
            {
                local trace = {
                    start = eyePos,
                    end = eyePos + forward * 5500,
                    mask = Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
                    ignore = self
                };
                TraceLineEx(trace);
                target = safeget(trace, "enthit", null);
            }
            if (IsValidPlayer(target) && IsTeammateOrSpy(self, target))
            {
                if (Time() - lastTimeUsedOn < buffDuration && lastPlayerUsedOn == target)
                    return;

                if (selectedBuffType == 0)
                    AttachBuff(target, TF_COND_OFFENSEBUFF, buffDuration);
                else if (selectedBuffType == 1)
                    AttachBuff(target, TF_COND_SPEED_BOOST, buffDuration);
                else
                    AttachBuff(target, TF_COND_DEFENSEBUFF, buffDuration);
                if (!IsSetup())
                    vipBoostTokens--;
                EmitSoundOnClient("Player.HitSoundRetro", self);
                lastTimeUsedOn = Time();
                lastPlayerUsedOn = target;
            }
            else
                EmitSoundOnClient("Player.DenyWeaponSelection", self);
        }
    }
    else if (pressedAttack2)
        pressedAttack2 = false;
});

function AttachBuff(player, condition, duration)
{
    local buffEnt = SpawnEntityFromTable("point_template", { });
    EntFireByHandle(buffEnt, "Kill", "", duration, self, self);
    AddTimer(0.1, 0, function()
    {
        if (IsValidPlayer(player))
            player.AddCondEx(condition, 0.2, self);
        else
            self.Kill();
    }, buffEnt);
}